> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nami.cloud/llms.txt
> Use this file to discover all available pages before exploring further.

# Put Object

> Upload an object to a bucket

<Note>
  Make sure you have WRITE permission on the bucket.
</Note>

## Put Object

Adds an object to a bucket. The object data is sent in the request body.

### Base URL

```bash theme={null}
https://${bucketname}.storage.nami.cloud
```

### Parameters

<ParamField path="objectKey" required>
  The key of the object to create
</ParamField>

### Headers

<ParamField header="Content-Length" required>
  Size of the object in bytes
</ParamField>

<ParamField header="Content-Type" optional>
  A standard MIME type describing the format of the object data
</ParamField>

<ParamField header="x-amz-storage-class" optional>
  Storage class to use for storing the object
</ParamField>

### Request Examples

<RequestExample>
  ```bash Bash theme={null}
  curl -X PUT "https://mybucket.storage.nami.cloud/example.jpg" \
    -H "Authorization: AWS4-HMAC-SHA256 Credential=AKIAIOSFODNN7EXAMPLE/20231028/us-east-1/s3/aws4_request, SignedHeaders=host;x-amz-date, Signature=fe5f80f77d5fa3beca038a248ff027d0445342fe2855ddc963176630326f1024" \
    -H "Content-Type: image/jpeg" \
    -H "Content-Length: 11434" \
    --data-binary "@example.jpg"
  ```

  ```python Python theme={null}
  import boto3

  s3_client = boto3.client('s3',
      endpoint_url='https://storage.nami.cloud',
      aws_access_key_id='YOUR_ACCESS_KEY',
      aws_secret_access_key='YOUR_SECRET_KEY'
  )

  with open('example.jpg', 'rb') as file:
      s3_client.put_object(
          Bucket='mybucket',
          Key='example.jpg',
          Body=file,
          ContentType='image/jpeg'
      )
  ```

  ```javascript Node.js theme={null}
  import { S3Client, PutObjectCommand } from "@aws-sdk/client-s3";
  import { readFileSync } from "fs";

  const client = new S3Client({
    endpoint: "https://storage.nami.cloud",
    credentials: {
      accessKeyId: "YOUR_ACCESS_KEY",
      secretAccessKey: "YOUR_SECRET_KEY",
    },
  });

  async function uploadFile() {
    const fileContent = readFileSync('example.jpg');
    
    const command = new PutObjectCommand({
      Bucket: "mybucket",
      Key: "example.jpg",
      Body: fileContent,
      ContentType: "image/jpeg"
    });

    try {
      const response = await client.send(command);
      console.log("Upload successful:", response);
    } catch (err) {
      console.error("Error:", err);
    }
  }

  uploadFile();
  ```

  ```go Golang theme={null}
  package main

  import (
      "github.com/aws/aws-sdk-go/aws"
      "github.com/aws/aws-sdk-go/aws/credentials"
      "github.com/aws/aws-sdk-go/aws/session"
      "github.com/aws/aws-sdk-go/service/s3"
      "os"
  )

  func main() {
      sess := session.Must(session.NewSession(&aws.Config{
          Endpoint:    aws.String("https://storage.nami.cloud"),
          Region:      aws.String("us-east-1"),
          Credentials: credentials.NewStaticCredentials("YOUR_ACCESS_KEY", "YOUR_SECRET_KEY", ""),
      }))

      s3Client := s3.New(sess)

      file, err := os.Open("example.jpg")
      if err != nil {
          panic(err)
      }
      defer file.Close()

      _, err = s3Client.PutObject(&s3.PutObjectInput{
          Bucket:      aws.String("mybucket"),
          Key:         aws.String("example.jpg"),
          Body:        file,
          ContentType: aws.String("image/jpeg"),
      })
      if err != nil {
          panic(err)
      }
  }
  ```

  ```rust Rust theme={null}
  use aws_sdk_s3::{Client, Config};
  use aws_config::credentials::StaticCredentialsProvider;
  use aws_types::region::Region;
  use tokio;

  #[tokio::main]
  async fn main() -> Result<(), Box<dyn std::error::Error>> {
      let credentials = StaticCredentialsProvider::new(
          "YOUR_ACCESS_KEY".to_string(),
          "YOUR_SECRET_KEY".to_string(),
          None,
      );

      let config = Config::builder()
          .endpoint_url("https://storage.nami.cloud")
          .region(Region::new("us-east-1"))
          .credentials_provider(credentials)
          .build();

      let client = Client::from_conf(config);

      let body = aws_sdk_s3::types::ByteStream::from_path("example.jpg").await?;

      client
          .put_object()
          .bucket("mybucket")
          .key("example.jpg")
          .body(body)
          .content_type("image/jpeg")
          .send()
          .await?;

      println!("Upload successful!");
      Ok(())
  }
  ```
</RequestExample>

### Response Example

```json theme={null}
HTTP/1.1 200 OK
x-amz-id-2: YgIPIfBiKa2bj0KMgUAdQkf3ShJTOOpXUueF6QKo
x-amz-request-id: 236A8905248E5A01
Date: Wed, 28 Oct 2023 22:32:00 GMT
ETag: "6805f2cfc46c0f04559748bb039d69ae"
Content-Length: 0
Server: Nami Cloud
```


## OpenAPI

````yaml PUT /{objectKey}
openapi: 3.0.1
info:
  title: Nami Cloud Storage API
  description: S3 compatible storage service API documentation
  version: 1.0.0
servers:
  - url: https://{bucketName}.storage.nami.cloud
    variables:
      bucketName:
        default: mybucket
        description: The name of the bucket
security:
  - awsV4: []
paths:
  /{objectKey}:
    put:
      tags:
        - Object Operations
      summary: Put Object
      description: Adds an object to a bucket
      parameters:
        - name: objectKey
          in: path
          required: true
          description: Key of the object
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/octet-stream:
            schema:
              type: string
              format: binary
      responses:
        '200':
          description: Object uploaded successfully
          headers:
            ETag:
              description: Entity tag for the uploaded object
              schema:
                type: string
components:
  securitySchemes:
    awsV4:
      type: apiKey
      name: Authorization
      in: header
      description: AWS Signature Version 4

````